/*
 *	emu.h
 *
 *	MNV[EH[Y/EMU
 *
 *	* Tue Dec 05 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __EMU_H__

/*{{main.c*/
extern unsigned char vbuff[DISP_X * DISP_Y];
extern int joy;
void schedule();
/*}}main.c*/

#define EMU_FPS		60
#define EMU_SKIP	0
#define EMU_SX		256
#define EMU_SY		256
#define EMU_X1		  8
#define EMU_Y1		 32
#define EMU_X2		247
#define EMU_Y2		255
#define EMU_VX		(EMU_X2 - EMU_X1 + 1) /* 1/2ĕ\B(DISP_X*2=256)ȉK{ */
#define EMU_VY		(EMU_Y2 - EMU_Y1 + 1) /* 1/3ĕ\B(DISP_Y*3=264)ȉK{ */
#define VRAM_ADDR	0x2000
#define CPU_CLOCK	2000000
#define CPU_CYCLE	(CPU_CLOCK / EMU_FPS)

extern unsigned char color_table[1 << 6];

typedef struct _EMU {
	/*{{̃̕CAEg͕ύXs*/
	Z80 z80;
	unsigned char mem[0x10000];
	/*}}̃̕CAEg͕ύXs*/
	unsigned char port[3];
} EMU;

typedef struct _ROM {
	const char* name;	/* NULL:I[ */
	unsigned short base;
	unsigned short size;
	unsigned crc;
} ROM;

typedef struct _GAME {
	const char* title;
	const char* fname;
	const ROM* rom;
	void (*init)(EMU* emu);
	void (*update_input)(EMU* emu);
} GAME;

void emu_main(const GAME* game);
void load_rom(const GAME* game);
void init_video();
void update_video(EMU* emu);

//unsigned char emu_read(Z80* z80, unsigned short addr);
//void emu_write(Z80* z80, unsigned short addr, unsigned char data);
unsigned char emu_in(Z80* z80, unsigned short addr);
void emu_out(Z80* z80, unsigned short addr, unsigned char data);

#endif /*__EMU_H__*/
