/*
 *	framemu.c
 *
 *	MNV[EH[Y/EMU
 *
 *	* Tue Dec 05 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

void
update_video(EMU* emu)
{
	unsigned char* vram = &emu->mem[VRAM_ADDR];
	unsigned char* table = color_table;

	unsigned char* dst;
	unsigned char* src;
	int x, y, n1, n2, n3;

	dst = &vbuff[DISP_X * (DISP_Y - (EMU_VY / 3)) / 2
		            + (DISP_X - (EMU_VX / 2)) / 2];
	src = &vram[(EMU_SX * (EMU_Y2 - (3 - 1))
			    + (EMU_X2 - (8 - 1))) / 8];

	for(y = 0; y < (EMU_VY / 3); y++) {
		for(x = 0; x < (EMU_VX / 2) / 4; x++) {
			n1 = src[  0 / 8];
			n2 = src[256 / 8];
			n3 = src[512 / 8];
			*dst++ = table[(n1 & 0xc0) >> 2 | (n2 & 0xc0) >> 4 | (n3 & 0xc0) >> 6];
			*dst++ = table[(n1 & 0x30) >> 0 | (n2 & 0x30) >> 2 | (n3 & 0x30) >> 4];
			*dst++ = table[(n1 & 0x0c) << 2 | (n2 & 0x0c) >> 0 | (n3 & 0x0c) >> 2];
			*dst++ = table[(n1 & 0x03) << 4 | (n2 & 0x03) << 2 | (n3 & 0x03) >> 0];
			src--;
		}
		dst += DISP_X - EMU_VX / 2;
		src -= ((EMU_SX - EMU_VX) + (EMU_SX * (3 - 1))) / 8;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

static          short shift_count;
static unsigned short shift_data;

unsigned char
emu_in(Z80* z80, unsigned short addr)
{
	EMU* emu = (EMU*)z80;

	switch(addr & 0xff) {
	case 0x00:
		return emu->port[0];
	case 0x01:
		return emu->port[1];
	case 0x02:
		return emu->port[2];
	case 0x03:
		return shift_data >> shift_count;
	}

	return -1;
}

void
emu_out(Z80* z80, unsigned short addr, unsigned char data)
{
	switch(addr & 0xff) {
	case 0x02:
		shift_count = 8 - (data & 7);
		break;
	case 0x04:
		shift_data = data << 8 | shift_data >> 8;
		break;
	}
}

